import {h} from 'preact';
import { useContext, useState } from 'preact/hooks';
import { route } from 'preact-router';
import { UserTable } from "../../store";
function EditUser({userid}){
    const { usertable, userreducer } = useContext(UserTable);
    let user = usertable.find(u=>u.uid===userid)
    const [formdata, formchange] = useState(user?user:{});
    const onChange=(e)=>{
        console.log(e);
        if(e.target.type==='checkbox')
            formchange({...formdata, [e.target.id]:e.target.checked})
        else
            formchange({...formdata, [e.target.id]:e.target.value})
    }
    const onSubmit=(e)=>{
        e.preventDefault();
        userreducer({type:'update', user: formdata})
        route('/users');
    }
    const Input = ({id, type='text', label, disabled})=>(<div><label for={id}>{label}</label><input disabled={disabled} type={type} checked={type=='checkbox'&&formdata[id]?'on':''} value={formdata[id]} id={id} onChange={onChange} name={`edit-${id}`} /></div>)
    return(
        <div className='container'>
        <h1>Benutzer Bearbeiten</h1>
        <form onSubmit={onSubmit}>
            <Input id="uid" label="UserID" />
            <Input id="first_name" label="Vorname" />
            <Input id="last_name" label="NachName" />
            <Input id="rfid_uid" label="RFID" />
            <Input id="user_pin" label="Pin" />
            <Input id="enabled" type={'checkbox'} label="Vorname" />
            <input type={'submit'}>Speichern</input>
        </form>    
        </div>
    )
}
export default EditUser;