import { h } from "preact";
import { UserList, Pageselector, Breadcrumbs } from "../../components";
import api from '../../api'
import { route } from 'preact-router';
import { useContext, useEffect, useState } from "preact/hooks";
import AppState, { UserTable } from "../../store";
function Users({ pageid }) {
    const [viewstate, setview] = useState({ limit: 100, page: 1, pages: null })
    const { usertable, userreducer } = useContext(UserTable);
    let [sessiondata, setsession] = useContext(AppState).session;
    const setPage = (e) => {
        e.preventDefault();
        console.log(e)
        let page = e.target.text;
        setview({ ...viewstate, page })
    }



    useEffect(() => {
        if (usertable === undefined)
        console.log("TOKEN");
            console.log(sessiondata.token);
            api.fetchdb(sessiondata.token).then(imported => {
                let action = { type: 'import', imported };
                userreducer(action);
            });
    },[sessiondata]);

    useEffect(() => {
        setview({ ...viewstate, pages: Math.ceil(usertable.length / viewstate.limit) });
        console.log("New View effect")
    }, [usertable])
    useEffect(() => {
        if (pageid && !isNaN(pageid))
            setview({ ...viewstate, page: pageid })
    }, [pageid])
    const deleteUser = (user) => {
        let action = {
            type: 'delete',
            user
        }
        userreducer(action)
    }
    const calculateView = () => {
        let start = viewstate.limit * (viewstate.page - 1);
        let end = viewstate.limit * (viewstate.page);
        return { start, end }
    }
    const editUser = (user) => {
        route(`/edituser/${user.uid}`);
    }
    const navigation = ["Users"];
    //
    return (
        <div class="container">
            <Breadcrumbs items={navigation} />
            <div>Suche: <input type={'text'} /><button>Hinzufügen</button> Limit: <select><optgroup label={'Anzahl'}><option>10</option><option>25</option><option>50</option><option>100</option></optgroup><option>Alle</option></select></div>
            <UserList {...calculateView()} userlist={usertable} deleteUser={deleteUser} editUser={editUser} />
            <Pageselector start={1} end={viewstate.pages} current={viewstate.page} setPage={setPage} />

        </div>
    );

}

export default Users;